Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/mesh.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/mesh.cpp	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/mesh.cpp	(revision 2127)
@@ -53,6 +53,6 @@
 ///////////////////////////////////////////////////////////////////////////////
 
-int VMI::findEdge(Edge *e, GLuint num, GLuint _u, GLuint _v) {
-    GLuint i, u, v;
+int VMI::findEdge(Edge *e, int num, int _u, int _v) {
+    int i, u, v;
     int found = -1; 
 
@@ -85,8 +85,4 @@
 		newList[*n].u = u;
     newList[*n].v = v;
-
-		// This edge has no triangle adjancency
-		newList[*n].numTriangles = 0;
-		newList[*n].triangles = NULL;
 		
 		// Enable the new edge
@@ -102,6 +98,50 @@
 }
 
+double VMI::computeEdgeLength(Vertex *vertices, int u, int v) {
+    float ux, uy, uz, vx, vy ,vz, rx, ry, rz;
+    
+    ux = vertices[u].x;
+    uy = vertices[u].y;
+    uz = vertices[u].z;
+
+    vx = vertices[v].x;
+    vy = vertices[v].y;
+    vz = vertices[v].z;
+
+    rx = ux - vx;
+    ry = uy - vy;
+    rz = uz - vz;
+
+    return sqrt((rx * rx) + (ry * ry) + (rz * rz));
+}
+
+double VMI::computeTriangleVolume(Vertex *vertices, Triangle *t) {
+    int i;
+    double m[3][3], vol;
+    
+    // Compute triangle Volume
+    i = t->indices[0];
+    m[0][0] = mesh->vertices[i].x;
+    m[0][1] = mesh->vertices[i].y;
+    m[0][2] = mesh->vertices[i].z;
+    
+    i = t->indices[1];
+    m[1][0] = mesh->vertices[i].x;
+    m[1][1] = mesh->vertices[i].y;
+    m[1][2] = mesh->vertices[i].z;
+
+    i = t->indices[2];
+    m[2][0] = mesh->vertices[i].x;
+    m[2][1] = mesh->vertices[i].y;
+    m[2][2] = mesh->vertices[i].z;
+    
+    vol = computeMatDet(m);
+    
+    //printf("Triangle Volume: %f\n", vol)
+    return vol;  
+}
+
 GLdouble VMI::computeTriangleArea(Vertex *vertices, Triangle *t) {
-    GLuint i;
+    int i;
     GLdouble v0[3], v1[3], v2[3], a;
     
@@ -129,5 +169,5 @@
 
 void VMI::computeTriangleNormal(Vertex *vertices, Triangle *t) {
-    GLuint i;
+    int i;
     GLfloat x0, y0, z0,
             x1, y1, z1,
@@ -175,5 +215,5 @@
 Mesh *VMI::initMesh(GLMmodel* pmodel) {
 
-    GLuint i, j, curGroup, v1, v2, v3, n, m, t;
+    int i, j, curGroup, v1, v2, v3, n, m, t;
     int e;
     Mesh *mesh;
@@ -202,5 +242,5 @@
     
     printf("Adding vertices...");
-    for (i=1; i<=pmodel->numvertices; i++) { // Vertices start at 1
+    for (i=1; i<=(int)pmodel->numvertices; i++) { // Vertices start at 1
         mesh->vertices[i - 1].x = pmodel->vertices[3 * i + 0];
         mesh->vertices[i - 1].y = pmodel->vertices[3 * i + 1];
@@ -208,4 +248,6 @@
         mesh->vertices[i - 1].numTriangles = 0;
         mesh->vertices[i - 1].triangles = NULL;
+				mesh->vertices[i - 1].numEdges = 0;
+        mesh->vertices[i - 1].edges = NULL;
         mesh->vertices[i - 1].enable = GL_TRUE;
     }
@@ -221,5 +263,5 @@
     while(group) {
         
-        for (i=0; i<group->numtriangles; i++) {
+        for (i=0; i<(int)group->numtriangles; i++) {
             
             t = group->triangles[i];
@@ -244,5 +286,5 @@
                 // Reallocate memory for the new adjacent triangle
                 mesh->vertices[v1].triangles = 
-					(GLuint *)realloc(mesh->vertices[v1].triangles, (mesh->vertices[v1].numTriangles + 1) * sizeof(GLuint));
+					(int *)realloc(mesh->vertices[v1].triangles, (mesh->vertices[v1].numTriangles + 1) * sizeof(int));
                 addItem((int *)mesh->vertices[v1].triangles, (int *)&mesh->vertices[v1].numTriangles, t);
             }
@@ -254,7 +296,7 @@
     for (i=0; i<pmodel->numtriangles; i++) {
         mesh->triangles[i].id = i;
-        mesh->triangles[i].indices[0] = pmodel->triangles[i].vindices[0] - 1;
-        mesh->triangles[i].indices[1] = pmodel->triangles[i].vindices[1] - 1;
-        mesh->triangles[i].indices[2] = pmodel->triangles[i].vindices[2] - 1;
+        mesh->triangles[i].indices[0] = (int)pmodel->triangles[i].vindices[0] - 1;
+        mesh->triangles[i].indices[1] = (int)pmodel->triangles[i].vindices[1] - 1;
+        mesh->triangles[i].indices[2] = (int)pmodel->triangles[i].vindices[2] - 1;
         mesh->triangles[i].area = computeTriangleArea(mesh->vertices, &mesh->triangles[i]);
         //printf("\n%d a: %f",i , mesh->triangles[i].area);
@@ -271,5 +313,5 @@
             // Reallocate memory for the new adjacent triangle
             mesh->vertices[v1].triangles = 
-			    (GLuint *)realloc(mesh->vertices[v1].triangles, (mesh->vertices[v1].numTriangles + 1) * sizeof(GLuint));
+			    (int *)realloc(mesh->vertices[v1].triangles, (mesh->vertices[v1].numTriangles + 1) * sizeof(int));
             addItem((int *)mesh->vertices[v1].triangles, (int *)&mesh->vertices[v1].numTriangles, i);
         }
@@ -304,19 +346,8 @@
             mesh->edges[n].u = v1;
             mesh->edges[n].v = v2;
-						mesh->edges[n].triangles    = NULL;
-        		mesh->edges[n].numTriangles = 0;
             mesh->edges[n].enable = GL_TRUE;
             m = n;
             n++;
         } else m = e;
-		// Reallocate memory for the new adjacent triangle
-        mesh->edges[m].triangles = 
-			(GLuint *)realloc(mesh->edges[m].triangles, (mesh->edges[m].numTriangles + 1) * sizeof(GLuint));
-        // Adding triangle i adjacent to edge m
-        addItem((int *)mesh->edges[m].triangles, (int *)&mesh->edges[m].numTriangles, i);
-        //printf("n:%d i:%d\n", m, i);
-        
-        // Adding edge m adjacent to triangle i
-        addItem((int *)mesh->triangles[i].edges, (int *)&t, m);
 
         /////////////////////////////////////////////////////////////////////////////////
@@ -325,19 +356,8 @@
             mesh->edges[n].u = v2;
             mesh->edges[n].v = v3;
-						mesh->edges[n].triangles    = NULL;
-        		mesh->edges[n].numTriangles = 0;
             mesh->edges[n].enable = GL_TRUE;
             m = n;
             n++;
         } else m = e;
-		// Reallocate memory for the new adjacent triangle
-        mesh->edges[m].triangles = 
-			(GLuint *)realloc(mesh->edges[m].triangles, (mesh->edges[m].numTriangles + 1) * sizeof(GLuint));
-        // Adding triangle i adjacent to edge m
-        addItem((int *)mesh->edges[m].triangles, (int *)&mesh->edges[m].numTriangles, i);
-        //printf("n:%d i:%d\n", m, i);
-        
-        // Adding edge m adjacent to triangle i
-        addItem((int *)mesh->triangles[i].edges, (int *)&t, m);
 
         /////////////////////////////////////////////////////////////////////////////////
@@ -346,28 +366,32 @@
             mesh->edges[n].u = v3;
             mesh->edges[n].v = v1;
-						mesh->edges[n].triangles    = NULL;
-        		mesh->edges[n].numTriangles = 0;
             mesh->edges[n].enable = GL_TRUE;
             m = n;
             n++;
         } else m = e;
-		// Reallocate memory for the new adjacent triangle
-        mesh->edges[m].triangles = 
-			(GLuint *)realloc(mesh->edges[m].triangles, (mesh->edges[m].numTriangles + 1) * sizeof(GLuint));
-        // Adding triangle i adjacent to edge m
-        addItem((int *)mesh->edges[m].triangles, (int *)&mesh->edges[m].numTriangles, i);
-        //printf("n:%d i:%d\n", m, i);
-        
-        // Adding edge m adjacent to triangle i
-        addItem((int *)mesh->triangles[i].edges, (int *)&t, m);
     }
     printf("Ok\n");
     mesh->numEdges = n;
 
+		for (i=0; i<mesh->numEdges; i++) {
+			v1 = mesh->edges[i].u;
+			v2 = mesh->edges[i].v;
+
+			mesh->vertices[v1].edges = 
+				(int *)realloc(mesh->vertices[v1].edges, (mesh->vertices[v1].numEdges + 1) * sizeof(int));
+			// Adding edge i adjacent to vertex v1
+			addItem(mesh->vertices[v1].edges, &mesh->vertices[v1].numEdges, i);
+
+			mesh->vertices[v2].edges = 
+				(int *)realloc(mesh->vertices[v2].edges, (mesh->vertices[v2].numEdges + 1) * sizeof(int));
+			// Adding edge i adjacent to vertex v2
+			addItem(mesh->vertices[v2].edges, &mesh->vertices[v2].numEdges, i);
+		}
+
     return mesh;
 }
 
 void VMI::printMesh(Mesh *mesh) {
-    GLuint i, j;
+    int i, j;
 
     printf("Vertices (%d)\n", mesh->numVertices);
@@ -385,4 +409,13 @@
         }
         printf("]\n");
+
+					printf("  e(%d)[", mesh->vertices[i].numEdges);
+        if (mesh->vertices[i].edges != NULL) {
+            printf("%d", mesh->vertices[i].edges[0]);
+            for (j=1; j<mesh->vertices[i].numEdges; j++) {
+                printf(",%d", mesh->vertices[i].edges[j]);
+            }
+        }
+        printf("]\n");
     }
 
@@ -391,12 +424,4 @@
     for (i=0; i<mesh->numEdges; i++) {
         printf("e%d (%d,%d) %d\n", i, mesh->edges[i].u, mesh->edges[i].v, mesh->edges[i].enable);
-        printf("  t(%d)[", mesh->edges[i].numTriangles);
-        if (mesh->edges[i].triangles != NULL) {
-            printf("%d", mesh->edges[i].triangles[0]);
-            for (j=1; j<mesh->edges[i].numTriangles; j++) {
-                printf(",%d", mesh->edges[i].triangles[j]);
-            }
-				}
-        printf("]\n");
     }
 
@@ -406,10 +431,4 @@
         printf("t%d (%d,%d,%d) %d\n", i, mesh->triangles[i].indices[0], mesh->triangles[i].indices[1],
                                      mesh->triangles[i].indices[2],  mesh->triangles[i].enable);
-        printf("  e(3)[");
-        printf("%d", mesh->triangles[i].edges[0]);
-        for (j=1; j<3; j++) {
-            printf(",%d", mesh->triangles[i].edges[j]);
-        }
-        printf("]\n");
 
         printf("  n(3)[");
@@ -425,5 +444,5 @@
 
 void VMI::deleteMesh(Mesh *mesh) {
-	GLuint i;
+	int i;
 
 	if (NULL != mesh) {
@@ -432,12 +451,11 @@
 				free(mesh->vertices[i].triangles);
 
+			if (mesh->vertices[i].edges != NULL)
+				free(mesh->vertices[i].edges);
+
 		}
 		if (mesh->vertices != NULL) free(mesh->vertices);
 		mesh->numVertices = 0;
 
-		for (i=0; i<mesh->numEdges; i++) {
-			if (mesh->edges[i].triangles != NULL)
-				free(mesh->edges[i].triangles);
-		}
 		if (mesh->edges != NULL) free(mesh->edges);
 		mesh->numEdges = 0;
@@ -525,50 +543,4 @@
 }
 
-int *VMI::edgesAdjToVertex(Mesh *mesh, int v, int *n) {
-    int *edges = NULL;
-    int i, t, e;
-#ifndef USE_EDGE_ADJACENCY
-    int n0, n1, n2;
-#else
-    int j;
-#endif
-    int num = 0;
-
-	if (mesh->vertices[v].numTriangles > 0) 
-		edges = (int*)malloc(sizeof(int) * mesh->vertices[v].numTriangles * 2);
-
-    for (i=0; i<(int)mesh->vertices[v].numTriangles; i++) {
-
-        t = mesh->vertices[v].triangles[i];
-
-#ifdef USE_EDGE_ADJACENCY
-        for (j=0; j<3; j++) {
-            e = mesh->triangles[t].edges[j];
-            
-            if ((int)mesh->edges[e].u == v || (int)mesh->edges[e].v == v)
-                
-                addItem(edges, &num, e);
-        }
-#else
-        n0 = mesh->triangles[t].indices[0];
-        n1 = mesh->triangles[t].indices[1];
-        n2 = mesh->triangles[t].indices[2];
-        
-        if (((n0 == v) || (n1 == v)) &&
-            ((e = findEdge(mesh->edges, mesh->numEdges, n0, n1)) != -1)) addItem(edges, &num, e);
- 
-        if (((n1 == v) || (n2 == v)) &&
-            ((e = findEdge(mesh->edges, mesh->numEdges, n1, n2)) != -1)) addItem(edges, &num, e);
-        
-        if (((n0 == v) || (n2 == v)) &&
-            ((e = findEdge(mesh->edges, mesh->numEdges, n0, n2)) != -1)) addItem(edges, &num, e);
-
-#endif
-    }
-    *n = num;
-
-    return edges;
-}
-
 int *VMI::edgesAdjToVertices(Mesh *mesh, int *vertices, int numVertices, int *n) {
     int *edges = NULL;
@@ -578,5 +550,6 @@
     if (numVertices > 0) {
         // Add the first
-        list = edgesAdjToVertex(mesh, vertices[0], &numEdges);
+		list = mesh->vertices[vertices[0]].edges;
+		numEdges = mesh->vertices[vertices[0]].numEdges;
 
         // Allocate memory
@@ -585,6 +558,4 @@
         memcpy(edges, list, sizeof(int) * numEdges);
 
-        free(list);
-
         num = numEdges;
 
@@ -592,8 +563,9 @@
         for (i=1; i<numVertices; i++) {
 
-            list = edgesAdjToVertex(mesh, vertices[i], &numEdges);
+			list = mesh->vertices[vertices[i]].edges;
+		    numEdges = mesh->vertices[vertices[i]].numEdges;
 
             // Reallocate memory
-			if (numEdges > 0) {
+            if (numEdges > 0) {
 
                 edges = (int *)realloc(edges, (num + numEdges + 1) * sizeof(int));
@@ -601,6 +573,5 @@
                 for (j=0; j<numEdges; j++)
                     addItem(edges, &num, list[j]);
-			}
-            free(list);
+            }
         }
     }
@@ -610,7 +581,7 @@
 }
 
-GLboolean VMI::findVertex(GLfloat *vertices, GLuint num, GLfloat x, GLfloat y, GLfloat z, int *pos) {
-    GLuint i;
-    GLfloat _x, _y, _z;
+GLboolean VMI::findVertex(float *vertices, int num, float x, float y, float z, int *pos) {
+    int i;
+    float _x, _y, _z;
     GLboolean found = GL_FALSE; 
     
@@ -648,4 +619,7 @@
 		newList[*n].numTriangles = 0;
 		newList[*n].triangles = NULL;
+
+		newList[*n].numEdges= 0;
+		newList[*n].edges = NULL;
 	
     // Enable the new vertex
@@ -663,8 +637,8 @@
 
 
-void VMI::updateModel(GLMmodel* pmodel, Mesh *mesh, GLuint numVertices, GLuint numTriangles) {
-    GLuint i , v1, v2 ,v3, numV = 1, numT = 0;
+void VMI::updateModel(GLMmodel* pmodel, Mesh *mesh, int numVertices, int numTriangles) {
+    int i , v1, v2 ,v3, numV = 1, numT = 0;
     int pos;
-    GLfloat x, y, z;
+    float x, y, z;
     
     if (pmodel->vertices != NULL) free(pmodel->vertices);
@@ -726,5 +700,5 @@
 
 void VMI::saveModel(char *filename, GLMmodel* pmodel, Mesh *mesh) {
-    GLuint i, j, g, numT = 0;
+    int i, j, g, numT = 0;
     GLMgroup *group;
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/simplify.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/simplify.cpp	(revision 2103)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/simplify.cpp	(revision 2127)
@@ -10,4 +10,5 @@
 #include "../include/saliency.h"
 #include "../include/histogram.h"
+#include "../include/buffers.h"
 
 //#define RECOMPUTE_THE_WHOLE_HEAP
@@ -59,5 +60,5 @@
 
 bheap_t *VMI::initHeap(Mesh *mesh) {
-	GLuint i;
+	int i;
 	double cost;
 	bheap_t *h = NULL;
@@ -152,22 +153,4 @@
 
 	return h;
-}
-
-GLdouble VMI::computeEdgeLength(Vertex *vertices, int u, int v) {
-	GLfloat ux, uy, uz, vx, vy ,vz, rx, ry, rz;
-
-	ux = vertices[u].x;
-	uy = vertices[u].y;
-	uz = vertices[u].z;
-
-	vx = vertices[v].x;
-	vy = vertices[v].y;
-	vz = vertices[v].z;
-
-	rx = ux - vx;
-	ry = uy - vy;
-	rz = uz - vz;
-
-	return sqrt((rx * rx) + (ry * ry) + (rz * rz));
 }
 
@@ -243,8 +226,8 @@
 ///////////////////////////////////////////////////////////////////////////////
 
-void saveProjectedAreas(GLuint **histogram, GLuint numCameras, Change *c, GLuint *dest) {
-	GLuint i, j, t, n = 0;
-
-	for (j=0; j<(GLuint)c->numDel; j++) {
+void saveProjectedAreas(int **histogram, int numCameras, Change *c, int *dest) {
+	int i, j, t, n = 0;
+
+	for (j=0; j<c->numDel; j++) {
 
 		t = c->deleted[j].id;
@@ -257,5 +240,5 @@
 	}
 
-	for (j=0; j<(GLuint)c->numMod; j++) { 
+	for (j=0; j<c->numMod; j++) { 
 
 		t = c->modified[j].id;
@@ -276,8 +259,8 @@
 }
 
-void loadProjectedAreas(GLuint *src, GLuint numCameras, Change *c, GLuint **histogram) {
-	GLuint i, j, t, n = 0;
-
-	for (j=0; j<(GLuint)c->numDel; j++) { 
+void loadProjectedAreas(int *src, int numCameras, Change *c, int **histogram) {
+	int i, j, t, n = 0;
+
+	for (j=0; j<c->numDel; j++) { 
 
 		t = c->deleted[j].id;
@@ -290,5 +273,5 @@
 	}
 
-	for (j=0; j<(GLuint)c->numMod; j++) { 
+	for (j=0; j<c->numMod; j++) { 
 
 		t = c->modified[j].id;
@@ -308,6 +291,49 @@
 	}
 }
-
 ///////////////////////////////////////////////////////////////////////////////
+#ifdef CHECK_LOCAL_INVERSION
+int check_local_inversion(Mesh *mesh, Change *c) {
+    int i, t;
+    int v0, v1, v2;
+    double vol_before;
+    double vol_after;
+    Triangle tri;
+    
+    for(i=0; i<mesh->vertices[c->u].numTriangles; i++) {
+        
+        t = mesh->vertices[c->u].triangles[i];
+        
+        v0 = mesh->triangles[t].indices[0];
+        v1 = mesh->triangles[t].indices[1];
+        v2 = mesh->triangles[t].indices[2];
+        
+        if ((v0 != c->v) && (v1 != c->v) && (v2 != c->v)) {
+            
+            //printf("%d\n", t);
+            memcpy(&tri, &mesh->triangles[t], sizeof(Triangle));
+            
+            vol_before = computeTriangleVolume(mesh->vertices, &tri);
+
+            //printf("t:[%d,%d,%d]\n", tri.indices[0], tri.indices[1], tri.indices[2]);
+            //printf("v:%f\n", vol_before);
+          
+            if (tri.indices[0] == c->u) tri.indices[0] = c->v;
+            if (tri.indices[1] == c->u) tri.indices[1] = c->v;
+            if (tri.indices[2] == c->u) tri.indices[2] = c->v;
+            
+            vol_after = computeTriangleVolume(mesh->vertices, &tri);
+
+            //printf("t:[%d,%d,%d]\n", tri.indices[0], tri.indices[1], tri.indices[2]);
+            //printf("v:%f\n", vol_after);
+
+            if (((vol_before > 0) && (vol_after < 0)) || 
+                ((vol_before < 0) && (vol_after > 0)))
+
+                return TRUE;
+        }
+    }
+    return FALSE;
+}
+#endif
 
 GLdouble VMI::computeEdgeCost(Mesh *mesh, int e) {
@@ -318,6 +344,12 @@
 	GLdouble newI;
 #endif
-	GLuint i, *histoAux = NULL;
+	int i, *histoAux = NULL;
 	Change *c;
+#if defined(VERTEX_BUFFER_OBJECTS) || defined(VERTEX_ARRAY)
+    VertexIL *vb = NULL;
+#endif
+#ifdef CHECK_LOCAL_INVERSION
+    int penalized;
+#endif
 
 	chooseBestEndPoints(mesh, e);
@@ -327,8 +359,18 @@
 
 	// Compute cost only for boundary or manifold edges
-	if (c->numDel == 2
-			/*(c->numDel <3) && (c->numDel > 0)*/) {
+	if (/*c->numDel == 2*/
+			(c->numDel <3) && (c->numDel > 0)) {
+
+#ifdef CHECK_LOCAL_INVERSION
+        penalized = check_local_inversion(mesh, c);
+#endif
 		// Allocate memory
-		histoAux = (GLuint *)malloc((c->numDel + c->numMod + 1) * numCameras * sizeof(GLuint));
+		histoAux = (int *)malloc((c->numDel + c->numMod + 1) * numCameras * sizeof(int));
+
+#if defined(VERTEX_BUFFER_OBJECTS) || defined(VERTEX_ARRAY)
+        vb = (VertexIL *)malloc((c->numDel + c->numMod + 1) * 3 * sizeof(VertexIL));
+
+        saveVertexBuffer(c, vb);
+#endif
 
 #ifdef MI // Mutual Information
@@ -365,5 +407,5 @@
 			//printf("  I0:%f Is: %f\n", auxE[i], initialIs[i]);
 
-			cost += (ABS(auxIs[i] - initialIs[i]) * cameras[i].weight * sal);
+			cost += (ABS(auxIs[i] - initialIs[i]) * cameras[i].weight);
 
 			// Restore old informations
@@ -405,5 +447,5 @@
 			newI = computeCS(mesh, histogram[i]);
 #endif
-			cost += (ABS(initialIs[i] - newI) * cameras[i].weight * sal);
+			cost += (ABS(initialIs[i] - newI) * cameras[i].weight);
 		}
 		undoChange(mesh, c);
@@ -417,4 +459,11 @@
 		// Free memory
 		free(histoAux);
+#if defined(VERTEX_BUFFER_OBJECTS) || defined(VERTEX_ARRAY)
+        loadVertexBuffer(vb, c);
+        free(vb);
+#endif
+#ifdef CHECK_LOCAL_INVERSION
+        if (penalized) cost *= 5;
+#endif
 
 	} else cost = FLT_MAX;
@@ -422,6 +471,25 @@
 	deleteChange(c);
 
-	return cost;
-}
+	return (cost * sal);
+}
+
+int isValidEdge_(Mesh *mesh, int e) {
+    int u , v;
+
+    if (mesh->edges[e].enable == FALSE) return FALSE;
+    else {
+        u = mesh->edges[e].u;
+        v = mesh->edges[e].v;
+
+        if (u == v) {
+
+            mesh->edges[e].enable = FALSE;
+            return FALSE;
+        }
+    }
+
+    return TRUE;
+}
+
 /* Get a valid edge from the heap */
 int getMinValidEdge(Mesh *mesh, bheap_t *h) {
@@ -431,5 +499,5 @@
 	e = bh_min(h);
 
-	while (mesh->edges[e].enable == FALSE) {
+	while (!isValidEdge_(mesh, e)) {
 		/* delete invalid edge */
 		bh_delete(h, e);
@@ -473,5 +541,5 @@
 
 ///////////////////////////////////////////////////////////////////////////
-void VMI::simplifyModel(Mesh *mesh, GLuint numDemandedTri)
+void VMI::simplifyModel(Mesh *mesh, int numDemandedTri)
 {
 	int			e;
@@ -558,4 +626,6 @@
 		bh_delete(h, e);
 
+		updateHWAcceleration(c);
+
 		// Get projected areas after the edge collapse
 		getProjectedAreas(histogram, numCameras);
@@ -563,6 +633,7 @@
 		computeCameraIs(histogram, numCameras, initialIs);
 
-		deleteEdges(mesh, c);
-		modifyEdges(mesh, c);
+		updateEdgeAdj(mesh, c);
+
+    modifyEdges(mesh, c);
 
 		// Update the heap according to the edge collapse
@@ -751,5 +822,4 @@
 
 	Edge		*econ;
-	float		x,y,z;
 	int			*lv1;
 	int			v0;
@@ -797,5 +867,6 @@
 			v1	=	(*lb1).second;
 
-			lv1	=	edgesAdjToVertex(mesh,v1,&num_edges);
+			lv1	=	mesh->vertices[v1].edges;
+			num_edges = mesh->vertices[v1].numEdges;
 
 			//	Edje iterator.
@@ -857,6 +928,6 @@
 
 			deleteVertexOfMap(mesh, c->u);
-			deleteEdges(mesh, c);
-			modifyEdges(mesh, c);
+			updateEdgeAdj(mesh, c);
+      modifyEdges(mesh, c);
 			deleteChange(c);
 
@@ -910,5 +981,7 @@
 			lonely_vert	=	(*it).second;
 
-			le	=	edgesAdjToVertex(mesh,lonely_vert,&num_edges);
+			le	=	mesh->vertices[lonely_vert].edges;
+
+			num_edges = mesh->vertices[lonely_vert].numEdges;
 
 			//	Find an edge width v coordinates.
@@ -977,6 +1050,6 @@
 
 				deleteVertexOfMap(mesh, c->u);
-				deleteEdges(mesh, c);
-				modifyEdges(mesh, c);
+				updateEdgeAdj(mesh, c);
+        modifyEdges(mesh, c);
 				deleteChange(c);
 			}
@@ -1069,6 +1142,6 @@
 
 				deleteVertexOfMap(mesh, c->u);
-				deleteEdges(mesh, c);
-				modifyEdges(mesh, c);
+				updateEdgeAdj(mesh, c);
+        modifyEdges(mesh, c);
 				deleteChange(c);
 			}
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/histogram.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/histogram.cpp	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/histogram.cpp	(revision 2127)
@@ -14,5 +14,5 @@
 using namespace VMI;
 
-void VMI::printHistogram(GLuint histoGram[][4]) {
+void VMI::printHistogram(int histoGram[][4]) {
     int i;
    
@@ -23,7 +23,7 @@
 }
 
-void VMI::plotHistogram(GLuint histoGram[][4]) {
+void VMI::plotHistogram(int histoGram[][4]) {
     int i;
-    GLuint iLargest = 0;  // Largest histogram value
+    int iLargest = 0;  // Largest histogram value
     GLfloat maxHeight = height / 2.0f;
         
@@ -72,9 +72,9 @@
 }
 
-GLuint **VMI::initHistogram(GLuint numTriangles, GLuint numCameras) {
-    GLuint i;
-    GLuint **histogram;
-
-    histogram = (GLuint **)malloc(sizeof(GLuint *) * numCameras);
+int **VMI::initHistogram(int numTriangles, int numCameras) {
+    int i;
+    int **histogram;
+
+    histogram = (int **)malloc(sizeof(int *) * numCameras);
 
     if (histogram == NULL) {
@@ -84,15 +84,15 @@
 
     for (i=0; i<numCameras; i++)
-    histogram[i] = (GLuint *)malloc(sizeof(GLuint) * (numTriangles + 1)); // + 1 because the last is the numPixels of the background
+    histogram[i] = (int *)malloc(sizeof(int) * (numTriangles + 1)); // + 1 because the last is the numPixels of the background
 
     // Fill the histogram buffer with 0
     for (i=0; i<numCameras; i++)
-    memset(histogram[i], 0, sizeof(GLuint) * (numTriangles + 1));
+    memset(histogram[i], 0, sizeof(int) * (numTriangles + 1));
 
     return histogram;
 }
 
-void VMI::deleteHistogram(GLuint **histogram, GLuint numCameras) {
-    GLuint i;
+void VMI::deleteHistogram(int **histogram, int numCameras) {
+    int i;
     
     for (i=0;i<numCameras;i++)
@@ -102,6 +102,6 @@
 }
 
-void VMI::printFullHistogram(GLuint **histogram, GLuint numCameras, GLuint numTriangles) {
-    GLuint i, j;
+void VMI::printFullHistogram(int **histogram, int numCameras, int numTriangles) {
+    int i, j;
     
     printf("\n");
@@ -116,5 +116,5 @@
 }
 
-void VMI::getSubHistogram(GLuint subHistoGram[][4]) {
+void VMI::getSubHistogram(int subHistoGram[][4]) {
     //printf("Computing histogram...\n");
     // Define the histogram
@@ -137,8 +137,8 @@
 }
 
-void VMI::copySubHistogram(Color *colors, GLuint *histogram, GLuint begin, GLuint end, GLuint subHistoGram[][4]) {
-    GLuint i;
+void VMI::copySubHistogram(Color *colors, int *histogram, int begin, int end, int subHistoGram[][4]) {
+    int i;
     GLubyte r, g, b, a;
-    GLuint h = 0;
+    int h = 0;
 
     for (i=begin; i<end; i++) {
@@ -165,7 +165,7 @@
 }
 
-void VMI::getSWHistogram(GLuint *histogram, GLubyte *pixels) {
+void VMI::getSWHistogram(int *histogram, GLubyte *pixels) {
     GLubyte r, g, b, a;
-    GLuint i, t, p, numPixels = width * height;
+    int i, t, p, numPixels = width * height;
 
     glReadPixels(0, 0, width, height, GL_RGBA, GL_UNSIGNED_BYTE, pixels);
@@ -188,5 +188,5 @@
 
 void VMI::getBoundingBox(Change *c, GLfloat min[3], GLfloat max[3]) {
-    GLuint  i, j, t, v;
+    int  i, j, t, v;
     GLfloat maxx = 0.0f, minx = 0.0f, 
             maxy = 0.0f, miny = 0.0f,
@@ -194,5 +194,5 @@
     
     /* get the max/mins */
-    for (i=0; i<(GLuint)c->numMod; i++) {
+    for (i=0; i<c->numMod; i++) {
         t = c->modified[i].id;
         
@@ -217,5 +217,5 @@
     }
 
-    for (i=0; i<(GLuint)c->numDel; i++) {
+    for (i=0; i<c->numDel; i++) {
         t = c->deleted[i].id;
         
@@ -322,8 +322,8 @@
 }
 
-void VMI::getSWHistogramWin(GLuint *histogram, GLubyte *pixels, GLfloat min[3], GLfloat max[3], Change *c) {
+void VMI::getSWHistogramWin(int *histogram, GLubyte *pixels, GLfloat min[3], GLfloat max[3], Change *c) {
     GLubyte r, g, b, a;
-    GLuint i, t, p, numPixels,
-          *histoAux = (GLuint *)calloc(mesh->numTriangles + 1, sizeof(GLuint));
+    int i, t, p, numPixels,
+          *histoAux = (int *)calloc(mesh->numTriangles + 1, sizeof(int));
     GLint minw[2], maxw[2], ox, oy, h, w;
 
@@ -369,6 +369,6 @@
     }
 
-    for (i=0; i<(GLuint)c->numMod; i++) {
-        t = (GLuint)c->modified[i].id;
+    for (i=0; i<c->numMod; i++) {
+        t = c->modified[i].id;
 
         histogram[t + 1] = histoAux[t + 1]; 
@@ -379,6 +379,6 @@
 }
 
-void VMI::getSWHistoByOcclusionQuery(Mesh *mesh, Color *colors, GLuint *histogram) {
-    GLuint i, v1, v2, v3;
+void VMI::getSWHistoByOcclusionQuery(Mesh *mesh, Color *colors, int *histogram) {
+    int i, v1, v2, v3;
     GLint area, totalArea = 0;
 
@@ -432,7 +432,7 @@
 }
 
-void VMI::resetSWHistogram(GLuint *histogram, GLuint numTriangles) {
+void VMI::resetSWHistogram(int *histogram, int numTriangles) {
 
     // Fill the histogram buffer with 0
-    memset(histogram, 0, sizeof(GLuint) * (numTriangles + 1));
-}
+    memset(histogram, 0, sizeof(int) * (numTriangles + 1));
+}
